
#include "colors.inc"
#include "textures.inc"

camera {
  location <0, 0, -30>
  right <.7955, 0, 0>
  up <0, 1, 0>
  sky <0, 1, 0>
  direction <0, 0, 1.8>
  look_at <0, 0, 0>                  
  angle 45
}
background 
{
                <1,1,1>
                
        
}

light_source 
{ 
        <0,10,-30> 
        color White
        rotate <0,10,0>        
}                                      
               
  
box
{
        <33,42,50>,<-33.5,-42,51> 
        pigment
        {
                image_map
                {
                        sys "sky.bmp" 
                }          
                translate <0.5,0.5,0>
                scale<70,85,70>
                
        }       
        finish
        {
                ambient 0.45
        }
} 
  
#declare shield_thickness = 1.5;
#declare lettering_thickness = 2;                             


// The right side (border) of the shield                             
#declare shield_right = union
{
        difference
        {
        
                union
                {
                        difference
                        {
                                cylinder
                                {
                                        <0,0,0>,<0,0,shield_thickness>,19
                                }
                                cylinder
                                {
                                        <0,0,100>,<0,0,-100>,18
                                }
                                box
                                {
                                        <-100,0,-100>,<100,100,100>
                                }
                        }
                        box
                        {
                                <16,0,0>,<19,1,shield_thickness>
                        }
                        box
                        {
                                <14,1,0>,<17,2,shield_thickness>
                        }
                        box
                        {
                                <0,2,0>,<15,3,shield_thickness>
                        }
                        translate <-19,0,0>    
                        rotate <0,0,-8>
                        translate<10,0,0>

                }
                box 
                {
                        <-101,-101,-101>,<0,101,101>
                }
        } 
}

// The right side of the shield backing                      
#declare shield_backing_right = union
{
        difference
        {
        
                union
                {
                        difference
                        {
                                cylinder
                                {
                                        <0,0,0.001+shield_thickness>,<0,0,shield_thickness>,19
                                }
                                box
                                {
                                        <-100,0,-100>,<100,100,100>
                                }
                        }
                        box
                        {
                                <0,0,0.001+shield_thickness>,<19,1,shield_thickness>
                        }
                        box
                        {
                                <0,1,0.001+shield_thickness>,<17,2,shield_thickness>
                        }
                        box
                        {
                                <0,2,0.001+shield_thickness>,<15,3,shield_thickness>
                        }
                        translate <-19,0,0>    
                        rotate <0,0,-8>
                        translate<10,0,0>

                }
                box 
                {
                        <-101,-101,-101>,<0,101,101>
                }
        } 
}

#declare the_w = union
{                                          
        // right vertical spire of 'w'
        difference
        {
                box
                {
                        <-0.75,7.5,0>,<-1.85,-10,lettering_thickness>
                }
                box
                {
                        <0,100,100>,<-100,-100,-100>
                        rotate <0,0,29>
                        translate <0,-8,0>
                }
                box
                {
                        <100,100,100>,<-100,0,-100>
                        rotate <0,0,6>
                        translate <0,7.5,0>
                }
        }                         
        //bottom right of 'w' (center spire)
        difference
        {       
                difference
                {
                        cylinder
                        {
                                <0,0,0>,<0,0,lettering_thickness>,30
                        }
                        cylinder
                        {
                                <0,0,-100>,<0,0,100>,28.9
                        }               
                        translate <0,17,0>
                        rotate <0,0,-37>
                        translate <14.8,-5,0>
                }
                box
                {
                        <100,100,100>,<-100,6.5,-100>
                        rotate<0,0,6>
                }
                box
                {
                        <100,100,100>,<-0.75,-100,-100>
                }
        }                    
        //bottom left of 'w'   
        difference
        {
                box
                {
                        <0,0,0>,<2.5,1.1,lettering_thickness>
                }
                box
                {
                        <0,100,100>,<-100,-100,-100>
                        rotate <0,0,-20>
                }
                rotate <0,0,40>
                translate <-4.9,-2.4,0>
        }     
        // leftmost spire of 'w'                         
        difference
        {                                 
                difference
                {
                        cylinder
                        {
                                <0,0,0>,<0,0,lettering_thickness>,19
                        }
                        cylinder
                        {
                                <0,0,-100>,<0,0,100>,17.9
                        }                   
                        translate < 10.8,8.29,0>
                }
                box
                {
                        <100,100,100>,<-100,5.5,-100>
                        rotate<0,0,6>
                }
                box
                {
                        <100,-1,100>,<-4.9,-100,-100>
                }                            
        }
}     

// The 'j'
#declare the_j = union
{
        // right vertical spire of 'j'
        difference
        {
                box
                {
                        <-0.75,7.5,0>,<-1.85,-10,lettering_thickness>
                }
                box
                {
                        <0,100,100>,<-100,-100,-100>
                        rotate <0,0,29>
                        translate <0,-8,0>
                }
                box
                {
                        <100,100,100>,<-100,0,-100>
                        rotate <0,0,6>
                        translate <0,7.5,0>
                }
        }
        //bottom of 'j'
        difference
        {       
                difference
                {
                        cylinder
                        {
                                <0,0,0>,<0,0,lettering_thickness>,30
                        }
                        cylinder
                        {
                                <0,0,-100>,<0,0,100>,28.9
                        }               
                        translate <0,17,0>
                        rotate <0,0,-16>
                        translate <14.8,-.9,0>
                }
                box
                {
                        <100,100,100>,<-100,1,-100>
                        rotate<0,0,6>
                }
                box
                {
                        <100,100,100>,<-0.75,-100,-100>
                }
        }
                     
}                                      

#declare the_band = difference
{
        cone
        {
                <0,1.75,0>,10.25
                <0,0,0>,9.95
        }
        cone
        {
                <0,1.76,0>,8
                <0,-0.01,0>,8.65 
                scale <1.1,1,1>
               

        }                      
        box
        {
                <8,10,0>,<-8,-10,100>
        }
        scale <1,1,0.3>
        rotate <30,0,0> 
        translate <0,-5,1.5>
        texture
        {
                pigment
                {
                        rgb <1,0.65,0.0>
                }
                finish 
                {
                        metallic
                        ambient 0.4
                        diffuse 0.7
                        brilliance 6
                        reflection 0.15
                
                }
        }
}

#declare the_band_glint = 
difference
{
        cone
        {
                <0,1.75,0>,10.251
                <0,0,0>,9.951
        }
        cone
        {
                <0,1.76,0>,10.25
                <0,-0.01,0>,9.94 
                scale <1.1,1,1>
               

        }                      
        box
        {
                <8,10,0>,<-8,-10,100>
        }
        rotate<0,95-(clock*190),0>
        texture
        {
                
                pigment
                {
                        gradient x
                        color_map
                        {
                                [0.0  rgb  <1,1,1>]
                                [0.0007  rgb  <1,0.65,0.0>] 
                                [0.001 rgb  <1,0.65,0.0>]
                                [0.06 rgbt  <1,1,1,1>]
                                     
                                [1    rgbt <1,1,1,1>]
                                      
                         }                
                                          
                        
                        scale<11,11,11>        
                }
                finish 
                {
                        ambient 1
                }     
                //uncomment the following line if you're rendering the glint.
                //rotate<0,95-(clock*190),0>     
                
                rotate<0,95-(0*190),0>     
                
        }
        scale <1,1,0.3>
        rotate <30,0,0> 
        translate <0,-5,1.5>
        
}
#declare lettering = union
{
        union
        {    
        //The facade of the letters
                text
                {
                        ttf "COPRGTB.TTF" "J" .001, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.151>
                        rotate<0,55,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "O" .001, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.151>
                        rotate<0,48,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "E" .001, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.151>
                        rotate<0,41,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "W" .001, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.151>
                        rotate<0,28,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "I" .001, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.151>
                        rotate<0,19,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "S" .001, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.151>
                        rotate<0,14,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "E" .001, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.151>
                        rotate<0,7,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "P" .001, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.151>
                        rotate<0,-6,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "I" .001, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.151>
                        rotate<0,-14,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "C" .001, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.151>
                        rotate<0,-20,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "T" .001, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.151>
                        rotate<0,-27,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "U" .001, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.151>
                        rotate<0,-34,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "R" .001, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.151>
                        rotate<0,-41,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "E" .001, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.151>
                        rotate<0,-48,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "S" .001, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.151>
                        rotate<0,-55,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                }
                texture
                {
                        pigment
                        {
                                //color red 1 green 0.5 blue 0.0
                                rgb <1,0.65,0.0>
                        }
                        finish 
                        {
                                metallic
                                ambient 0.4
                                diffuse 0.7
                                brilliance 6
                                reflection 0.35
                                //phong 0.75
                                //phong_size 80
                        }
                }
        }
        union
        {         
        //The deep letters         
                text
                {
                        ttf "COPRGTB.TTF" "J" 1, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.15>
                        rotate<0,55,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "O" 1, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.15>
                        rotate<0,48,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "E" 1, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.15>
                        rotate<0,41,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "W" 1, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.15>
                        rotate<0,28,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "I" 1, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.15>
                        rotate<0,19,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "S" 1, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.15>
                        rotate<0,14,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "E" 1, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.15>
                        rotate<0,7,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "P" 1, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.15>
                        rotate<0,-6,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "I" 1, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.15>
                        rotate<0,-14,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "C" 1, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.15>
                        rotate<0,-20,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "T" 1, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.15>
                        rotate<0,-27,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "U" 1, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.15>
                        rotate<0,-34,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "R" 1, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.15>
                        rotate<0,-41,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "E" 1, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.15>
                        rotate<0,-48,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
                text
                {
                        ttf "COPRGTB.TTF" "S" 1, 0
                        scale<1,1.7,1>
                        translate <0,0.25,0>
                        rotate<-10,0,0>
                        translate <0,0,-10.15>
                        rotate<0,-55,0>
                        scale<1,1,0.3>
                        rotate<30,0,0>
                        translate<0,0,1.5>
                 }
        
        
        
                 texture
                {
                        pigment
                        {
                                //color red 1 green 0.5 blue 0.0
                                rgb <0.7,0.35,0>
                        }
                        finish 
                        {
                                metallic
                                ambient 0.3
                                diffuse 0.7
                                brilliance 6
                                reflection 0.25
                                //phong 0.75
                                //phong_size 80
                        }
                }
        }
}    

#declare the_emblem = union
{         
        object
        {
                shield_right
                rotate <0,-15,0>
        }
        object
        {
                shield_right
                rotate<0,180,0>
                translate<0,0,shield_thickness>
                rotate <0,15,0>
                
        }
        object
        {
                the_w
                translate <0,-5,-lettering_thickness>
                rotate <0,-195,0>
        }
        object
        {
                the_j 
                translate <0,-5,0>
                rotate <0,15,0>
        }      
        object
        {
                the_band
        }               
        object
        {
                the_band_glint
        }              
        union
        {
                difference
                {                   
                        object
                        {
                                shield_backing_right                      
                                rotate<0,-15,0>
                        }
                        box
                        {
                                <-0.001,100,100>,<-100,-100,-100>
                        }
                }
                difference
                {                
                        object
                        {
                                shield_backing_right                      
                                rotate<0,180,0>
                                translate<0,0,2*shield_thickness>
                                rotate<0,15,0>
                        }
                        box
                        {
                                <100,100,100>,<0.001,-100,-100>
                        }
                }
                texture
                {                 
                        normal
                        {
                                bumps 0.25
                                scale <1.2,1.2,1.2>
                        }
                        pigment
                        {
                                //color red 1 green 0.5 blue 0.0
                                rgb <0,0,1>
                        }
                        
                        finish 
                        {
                                //metallic
                                //ambient 0.4
                                //diffuse 0.7
                                //brilliance 6
                                //reflection 0.25
                                phong 0.25
                                phong_size 1
                        }               
                }
        }
        object
        {
                lettering
                translate <0,-5,0>
        }                
        translate <0,5,0>
        texture
        {
                pigment
                {
                        //color red 1 green 0.5 blue 0.0
                        rgb <1,0.65,0.0>
                }
                finish 
                {
                        metallic
                        ambient 0.4
                        diffuse 0.7
                        brilliance 6
                        reflection 0.25
                        //phong 0.75
                        //phong_size 80
                }
        }           
}
  
object
{
        the_emblem      
        // comment out the next three lines if you're rendering the glint
        #declare emblem_clock = ((((0.5*sin (pow(clock,(1/1.5))*pi-.5*pi))+.5))) ;
        rotate<90-(emblem_clock*90),0,0>
        translate<-5+(emblem_clock*5),-10+(emblem_clock*10),-22+(emblem_clock*22)>
 
        no_shadow
}             
 